'use strict';

const fs = require('fs').promises;

const dictionary = require('./dictionary.json');

async function init() {
	const validWords = Object.entries(dictionary).filter(([word]) => /^[a-zA-Z]+$/.test(word));

	const sortedWords = validWords.reduce((acc, [rawWord, fullDefinition]) => {
		const word = rawWord.toLowerCase();
		const anagram = word.split('').sort().join('');
		const definitions = fullDefinition.split(/\d+\.\s+/).filter(Boolean).map((definition) => definition.split('.')[0].toLowerCase());

		if (!acc[anagram.length]) {
			acc[anagram.length] = {};
		}

		if (!acc[anagram.length][anagram]) {
			acc[anagram.length][anagram] = [];
		}

		acc[anagram.length][anagram].push({ word, definitions });

		return acc;
	}, {});

	await fs.writeFile('./mash-words.json', JSON.stringify(sortedWords, null, 4));

	console.log(sortedWords);
}

init();
